<id>
Board Rules for YaBB 2.4
</id>

<version>
0.3
</version>

<mod info>
Description
-----------
Adds Board Rules to your forum

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.

Files to edit
-------------
Admin/ManageBoards.pl 
Admin/ModList.pl 
Languages/English/Admin.lng
Sources/Load.pl
Sources/MessageIndex.pl
Templates/default/MessageIndex.template
Templates/yabb21/MessageIndex.template

Version History
---------------
V0.1 - First release - 19th October 2009
V0.2 - Fixed board setting issues and removed unwanted html - 20th October 2009
V0.3 - Removed unneeded edit from Load.pl - 25th October 2009
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ManageBoards.pl
</edit file>

<search for>
			$rbinch    = qq~ disabled="disabled"~;
			$rbinexist = 1;
		}
</search for>

<add after>

		### Board Rules mod start ###
		$en_rules = "";
		if (${$uid.$id}{'rules'} == 1) { $en_rules = qq~ checked="checked"~; }
		$rulestitle = ${$uid.$editboards[$i]}{'rulestitle'};
		&ToChars($rulestitle);
		$rulesdesc = ${$uid.$editboards[$i]}{'rulesdesc'};
		$rulesdesc =~ s~<br />~\n~g;
		&ToChars($rulesdesc);
		### Board Rules mod end ###
</add after>

<search for>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" id="rbin$i" name="rbin$i" value="1" $rbinch onclick="javascript: if (this.checked) checkbin(true, '$i'); else checkbin(false, '$i');" /> $admin_txt{'64j'}</td>
  </tr><tr>
</search for>

<add after>
    <td class="catbg"  colspan="4"><b>$admin_txt{'rules'}:</b></td>
  </tr><tr>
    <td class="windowbg" width="25%" align="left"><b>$admin_txt{'rules1'}:</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="checkbox" name="rules$i" value="1"$en_rules /></td>
  </tr><tr>
    <td class="windowbg"  width="25%" align="left"><b>$admin_txt{'rules2'}:</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><input type="text" name="rulestitle$i" value="$rulestitle" size="50" maxlength="100" /></td>
  </tr><tr>
    <td class="windowbg" width="25%" align="left"><b>$admin_txt{'rules3'}:</b></td>
    <td class="windowbg2" width="75%" colspan="3" align="left"><textarea name="rulesdesc$i" rows="5" cols="30" style="width:98%; height:60px">$rulesdesc</textarea></td>
  </tr><tr>
</add after>

<search for>
		if ($FORM{"maxage$i"} && $FORM{"maxage$i"} < $FORM{"minage$i"}) { $FORM{"maxage$i"} = $FORM{"minage$i"}; }
</search for>

<add after>

		### Board Rules mod start ###
		if ($FORM{"rules$i"} eq '') { $FORM{"rules$i"} = 0; }
		$brulestitle = $FORM{"rulestitle$i"};
		&FromChars($brulestitle);
		$brulesdesc = $FORM{"rulesdesc$i"};
		&FromChars($brulesdesc);
		$brulesdesc =~ s/\r//g;
		$brulesdesc =~ s~\n~<br \/>~g;
		### Board Rules mod end ###
</add after>

<search for>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}\n");
</search for>

<replace>
		push(@boardcontrol, "$FORM{\"cat$i\"}|$id|$FORM{\"pic$i\"}|$bdescription|$FORM{\"moderators$i\"}|$FORM{\"moderatorgroups$i\"}|$FORM{\"topicperms$i\"}|$FORM{\"replyperms$i\"}|$FORM{\"pollperms$i\"}|$FORM{\"zero$i\"}|$FORM{\"membergroups$i\"}|$FORM{\"ann$i\"}|$FORM{\"rbin$i\"}|$FORM{\"att$i\"}|$FORM{\"minage$i\"}|$FORM{\"maxage$i\"}|$FORM{\"gender$i\"}|$FORM{\"rules$i\"}|$brulestitle|$brulesdesc\n");
</replace>

<search for>
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender) = split(/\|/, $oldcontrols[$cnt]);
</search for>

<replace>
			my (undef, $oldboard,$pic,$bdescription,$moderators,$moderatorgroups,$topicperms,$replyperms,$pollperms,$zero,$membergroups,$ann,$rbin,$att,$minage,$maxage,$gender,$rules,$brulestitle,$brulesdesc) = split(/\|/, $oldcontrols[$cnt]);
</replace>

<search for>
				$oldcontrols[$cnt] = qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender~;
</search for>

<replace>
				$oldcontrols[$cnt] = qq~$category|$moveitem|$pic|$bdescription|$moderators|$moderatorgroups|$topicperms|$replyperms|$pollperms|$zero|$membergroups|$ann|$rbin|$att|$minage|$maxage|$gender|$rules|$brulestitle|$brulesdesc~;
</replace>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$mod_boardrules = "Board Rules|Derek Barnstorm|Adds Board Rules to your forum|0.3|25th October 2009";
	push (@installed_mods, "$mod_boardrules");
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'65' => 'Group Permissions',
</search for>

<add before>
### Board Rules mod start ###
'rules' => 'Board Rules',
'rules1' => 'Enable Board Rules',
'rules2' => 'Rules Title',
'rules3' => 'Rules',
### Board Rules mod end ###
</add before>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
		($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntmembergroups, $cntann, $cntrbin, $cntattperms, $cntminageperms, $cntmaxageperms, $cntgenderperms, $rules, $rulestitle, $rulesdesc) = split(/\|/, $boardline);
</replace>

<search for>
			'genderperms'  => $cntgenderperms,);
</search for>

<replace>
			'genderperms'  => $cntgenderperms,
            'rules'        => $rules,
			'rulestitle'   => $rulestitle,
			'rulesdesc'    => $rulesdesc,);
</replace>

<search for>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $rules, $rulestitle, $rulesdesc) = split(/\|/, $boardline);
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$rules|$rulestitle|$rulesdesc\n");
</replace>

<search for>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms) = split(/\|/, $boardline);
</search for>

<replace>
			($cntcat, $cntboard, $cntpic, $cntdescription, $cntmods, $cntmodgroups, $cnttopicperms, $cntreplyperms, $cntpollperms, $cntzero, $cntpassword, $cnttotals, $cntattperms, $spare, $cntminageperms, $cntmaxageperms, $cntgenderperms, $rules, $rulestitle, $rulesdesc) = split(/\|/, $boardline);
</replace>

<search for>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms\n");
</search for>

<replace>
			push(@boardcontrol, "$cntcat|$cntboard|$cntpic|$cntdescription|$cntmods|$cntmodgroups|$cnttopicperms|$cntreplyperms|$cntpollperms|$cntzero|$cntpassword|$cnttotals|$cntattperms|$spare|$cntminageperms|$cntmaxageperms|$cntgenderperms|$rules|$rulestitle|$rulesdesc\n");
</replace>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	$messageindex_template =~ s/({|<)yabb colspan(}|>)/$colspan/g;
</search for>

<add after>

	### Board Rules mod start ###
	if (${$uid.$currentboard}{'rules'} == 1) {
        $rulestitle = ${$uid.$currentboard}{'rulestitle'};
	    $rulesdesc = ${$uid.$currentboard}{'rulesdesc'};
		&ToChars($rulestitle);
	    &ToChars($rulesdesc);
	    $messageindex_template =~ s/({|<)yabb rulestitle(}|>)/$rulestitle/g;
		$messageindex_template =~ s/({|<)yabb rulesdescription(}|>)/$rulesdesc/g;
	    }
    ### Board Rules mod end ###
</add after>

<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
<!-- Board Description end -->


~;
}
</search for>

<add after>

if (${$uid.$currentboard}{'rules'} == 1) {
$messageindex_template .= qq~

<!-- Board Rules start -->

<div class="displaycontainer">
<table cellpadding="3" cellspacing="0" border="0" width="100%">
<tr>
    <td class="titlebg" height="18" align="left">{yabb rulestitle}</td>
</tr>
<tr>
    <td class="windowbg" align="left">{yabb rulesdescription}</td>
</tr>
</table>
</div>
<br />

<!-- Board Rules end -->

~;
}

</add after>

<edit file>
Templates/yabb21/MessageIndex.template
</edit file>

<search for>
	<yabb description>
	<br /><br /></td>
</tr>
</table>
</div>~;
}
</search for>

<add after>

if (${$uid.$currentboard}{'rules'} == 1) {
$messageindex_template .= qq~

<!-- Board Rules start -->

<br />
<div class="displaycontainer">
<table cellpadding="3" cellspacing="0" border="0" width="100%">
<tr>
    <td class="titlebg" height="18" align="left"><yabb rulestitle></td>
</tr>
<tr>
    <td class="windowbg" align="left"><yabb rulesdescription></td>
</tr>
</table>
</div>
<br />

<!-- Board Rules end -->

~;
}

</add after>